// Cel_Sculppreview #0.6 - Sculptie previewer - Elout de Kok 2007
// SL name: Cel Edman
// 
// provided under the Creative Commons license.
// http://creativecommons.org/licenses/by-nc-sa/1.0/

// processing 0124 beta enviroment.
// -> http://processing.org/download/index.html (download processing for free)

// NOTE: this current version works only with 64*64 pixel size textures! (and I use the PNG / JPG format to load them, for testing)
// It`s a simple preview for the new sculpted objects 2nd life can use, after the 23 may 2007 patch
// Not tested on actual / live server yet, since I`m around 2nd life just for a week now and got no L$ yet

// Read tech notes on 2nd-life forums about sculpted prims -> http://wiki.secondlife.com/wiki/Sculpted_Prims
// To be short: Am image becomes 3D object - where for every pixel R=X G=Y Z=B 

// Some of the basic shapes I got , I saved them as PNG-24bit 64*64 pixels; 
// Then i can import them into processing (processing cant load bmp files!)
// Four types of images ( .gif, .jpg, .tga, .png) images can be loaded.

import processing.opengl.*;
import javax.swing.*; //for filechooser

// My sculpt 3D-image 
PImage b;
PImage loadbutton;
PImage abouttxt;

//for mouse and rotation
int mx,my,sx=140,sy=120, midx,midy;
float zangle;
float zpos=350.0f; //250 camera-position

// Max Texture size atm 2nd life is using - 64 by 64 pixels
int sculptsize=64; 

// Extra show the color of XYZ data
int [] sculptr = new int[sculptsize*sculptsize];
int [] sculptg = new int[sculptsize*sculptsize];
int [] sculptb = new int[sculptsize*sculptsize];

//3d object
float [] spx = new float[sculptsize*sculptsize];
float [] spy = new float[sculptsize*sculptsize];
float [] spz = new float[sculptsize*sculptsize];

int rendermodez=0;

//This is the scale of the Sculptie we draw!
float scaler=5.5f;
  
void setup() 
{


  // select now a 64*64 sculpt-image
  
  //b = loadImage("testgrid.png");
  //b = loadImage("Rounded_cube.jpg");
  // b = loadImage("apple.png");
  // b = loadImage("sculptplate.png");  
  //b = loadImage("sculpttest01.png");
  //b = loadImage("data/cube.png");
  //b = loadImage("sculptbanana1.png");  
  //b = loadImage("vase.png");
  //b = loadImage("sculptstem1.png");
  //b = loadImage("sculpts.png");  
  //b = loadImage("vase2.png");
  b = loadImage("data/juicer.jpg");
  //b = loadImage("Camilla.png");
  
    
  loadbutton= loadImage("data/loadbutton.png");
  abouttxt= loadImage("data/text.png");

  size(500, 500, OPENGL);
  midx=width/2;
  midy=height/2;

  noStroke();
  getimagedata();
}

void draw() 
{
  //clear with a background color, little touch of blue used now
  background(0,0,50);
  lights();
 
  //show the sculpt image top left corner
  fill(255,  255, 255, 255);
  image(b, 0, 0);
  image(loadbutton, width-97, 1);
  image(abouttxt, width-338, height-15);
  
  // Set object a bit in the middle   
  translate(midx, midy, zpos); 
  
  //check mouse-position for rotation of the object
  mx=mouseX;
  my=mouseY;
  if ( mx > midx){sx=0-((midx-mx)/2);}
  else{sx=((mx-midx)/2);}
  if ( my > midy){sy=0-((midy-my)/2);}
  else{sy=((my-midy)/2);}
  zangle= zangle+(sx/1000.0f);
  rotateX(0.6+(sy/40.0));
  rotateY(0.6+(sx/40.0));
  rotateZ(zangle);

  //draw the object
  pushMatrix();
   drawsculpt();
  popMatrix();
}

void mousePressed() 
{
  rendermodez++;
  if (rendermodez>2){rendermodez=0;}
  
  if(mx>width-97 && my<20){loadnewimage();}
}

void loadnewimage() 
{
  // filechooser from http://www.processinghacks.com/hacks/filechooser
  try { 
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
  } 
  catch (Exception e) { 
    e.printStackTrace();  
  } 

  // create a file chooser 
  final JFileChooser fc = new JFileChooser(); 
  int returnVal = fc.showOpenDialog(this); 
  
  if (returnVal == JFileChooser.APPROVE_OPTION) 
  { 
    File file = fc.getSelectedFile(); 
    // load the image using the given file path
    b = loadImage(file.getPath()); 
    if (b != null) 
    { 
        getimagedata();
        rendermodez=0;
    }
  }
  
}


void getimagedata()
{         
  //get the image data
  image(b, 0, 0, sculptsize, sculptsize);
  // get the RGB Data  
  for (int j=0;j<sculptsize;j++)
  {
    for (int i=0;i<sculptsize;i++)
    {
        sculptr[(j*sculptsize)+i]=((b.pixels[(j*sculptsize)+i] >> 16) & 0xff);
        sculptg[(j*sculptsize)+i]=((b.pixels[(j*sculptsize)+i] >>  8) & 0xff);
        sculptb[(j*sculptsize)+i]=(b.pixels[(j*sculptsize)+i] & 0xff);
    }
  }
  // set the X,Y an Z values now
  for (int j=0;j<sculptsize;j++)
  {
    for (int i=0;i<sculptsize;i++)
    {
        spx[(j*sculptsize)+i]=((sculptr[(j*sculptsize)+i]-128)/scaler);
        spy[(j*sculptsize)+i]=((sculptg[(j*sculptsize)+i]-128)/scaler);
        spz[(j*sculptsize)+i]=((sculptb[(j*sculptsize)+i]-128)/scaler);
    }
  }

}

void drawsculpt()
{         
      if (rendermodez==0){noStroke();}            // colormapped
      if (rendermodez==1){noStroke();}            // plain white
      if (rendermodez==2){stroke(155,155,155);}   // wireframe
        
      pushMatrix();
      
      beginShape(TRIANGLES);
      
      //draw the main thing 
      for (int j=0;j<sculptsize-2;j++)
      {        
          for (int i=0;i<sculptsize;i++)
          {
            //get the color
            if (rendermodez==0){fill(sculptr[(j*sculptsize)+i],  sculptg[(j*sculptsize)+i], sculptb[(j*sculptsize)+i],255);}
            if (rendermodez==1){fill(225,  225, 225, 255);}
            if (rendermodez==2){noFill();}
            
            if (rendermodez==0){fill(sculptr[(j*sculptsize)+i],  sculptg[(j*sculptsize)+i], sculptb[(j*sculptsize)+i],255);}
            //draw the quad square
            drawtri3d(  
                    spx[(j*sculptsize)+i],      spy[(j*sculptsize)+i],     spz[(j*sculptsize)+i],
                    spx[((j)*sculptsize)+i+1],  spy[((j)*sculptsize)+i+1], spz[((j)*sculptsize)+i+1],
                    spx[((j+1)*sculptsize)+i],  spy[((j+1)*sculptsize)+i], spz[((j+1)*sculptsize)+i]
                   );
            drawtri3d(  
                    spx[(j*sculptsize)+i+1],    spy[(j*sculptsize)+i+1],   spz[(j*sculptsize)+i+1],
                    spx[((j+1)*sculptsize)+i+1],  spy[((j+1)*sculptsize)+i+1], spz[((j+1)*sculptsize)+i+1],
                    spx[((j+1)*sculptsize)+i],  spy[((j+1)*sculptsize)+i], spz[((j+1)*sculptsize)+i]
                   );  
          }
      } 
      
      //draw now just the bottom parts I missed of the sculpted picture 
      for (int i=0, j=sculptsize-2; i<sculptsize; i++)
      {
            if (rendermodez==0){fill(sculptr[(j*sculptsize)+i],  sculptg[(j*sculptsize)+i], sculptb[(j*sculptsize)+i],255);}
            if (rendermodez==1){fill(225,  225, 225, 255);}
            if (rendermodez==2){noFill();}
            
            drawtri3d(  
                    spx[(j*sculptsize)+i],      spy[(j*sculptsize)+i],       spz[(j*sculptsize)+i],
                    spx[(j*sculptsize)+i+1],    spy[(j*sculptsize)+i+1],     spz[(j*sculptsize)+i+1],
                    spx[((j+1)*sculptsize)+i],  spy[((j+1)*sculptsize)+i],   spz[((j+1)*sculptsize)+i]
                   ); 
      }
      for (int i=0, j=sculptsize-2; i<sculptsize-1; i++)
      {
            if (rendermodez==0){fill(sculptr[(j*sculptsize)+i],  sculptg[(j*sculptsize)+i], sculptb[(j*sculptsize)+i],255);}
            if (rendermodez==1){fill(225,  225, 225, 255);}
            if (rendermodez==2){noFill();}
            drawtri3d(  
                    spx[(j*sculptsize)+i+1],    spy[(j*sculptsize)+i+1],     spz[(j*sculptsize)+i+1],
                    spx[((j+1)*sculptsize)+i],  spy[((j+1)*sculptsize)+i],   spz[((j+1)*sculptsize)+i],
                    spx[((j+1)*sculptsize)+i+1],  spy[((j+1)*sculptsize)+i+1], spz[((j+1)*sculptsize)+i+1]
                   );
      }
      
      //Since there seems holes in the object on top and bottom, so I want to close the object. Closing points are no#32 on top and bottom row.
      //closing top
      for (int i=0, j=0; i<sculptsize; i++)
      {
            if (rendermodez==0){fill(sculptr[(j*sculptsize)+i],  sculptg[(j*sculptsize)+i], sculptb[(j*sculptsize)+i],255);}
            if (rendermodez==1){fill(225,  225, 225, 255);}
            if (rendermodez==2){noFill();}
            drawtri3d(  
                    spx[(j*sculptsize)+i],    spy[(j*sculptsize)+i],     spz[(j*sculptsize)+i],
                    spx[((j)*sculptsize)+i+1],  spy[((j)*sculptsize)+i+1],   spz[((j)*sculptsize)+i+1],
                    spx[32],spy[32],spz[32]
                   );                   
      }
      //closing bottom
        for (int i=0, j=sculptsize-2; i<sculptsize; i++)
        {
            if (rendermodez==0){fill(sculptr[(j*sculptsize)+i],  sculptg[(j*sculptsize)+i], sculptb[(j*sculptsize)+i],255);}
            if (rendermodez==1){fill(225,  225, 225, 255);}
            if (rendermodez==2){noFill();}
            drawtri3d(  
                    spx[(j*sculptsize)+i],    spy[(j*sculptsize)+i],     spz[(j*sculptsize)+i],
                    spx[((j)*sculptsize)+i+1],  spy[((j)*sculptsize)+i+1],   spz[((j)*sculptsize)+i+1],
                    spx[(sculptsize*sculptsize)-32], spy[(sculptsize*sculptsize)-32], spz[(sculptsize*sculptsize)-32]
                   );
        }

      endShape();
      popMatrix();
}

void drawtri3d(float x1,float  y1,float  z1, float  x2,float  y2,float  z2, float  x3,float  y3,float  z3)
{
  vertex(x1, y1, z1);
  vertex(x2, y2, z2);
  vertex(x3, y3, z3);
}

